## mingw-w64-openblas-0.3.28-3.src.tar.zst

=== interface/Makefile ===
TOPDIR	= ..
include $(TOPDIR)/Makefile.system

SUPPORT_GEMM3M = 0

ifeq ($(ARCH), x86)
SUPPORT_GEMM3M = 1
endif

ifeq ($(ARCH), x86_64)
SUPPORT_GEMM3M = 1
endif

ifeq ($(ARCH), ia64)
SUPPORT_GEMM3M = 1
endif

ifeq ($(ARCH), MIPS)
SUPPORT_GEMM3M = 1
endif

ifneq ($(NO_FBLAS), 1)

SBLAS1OBJS    = \
		saxpy.$(SUFFIX) sswap.$(SUFFIX) \
		scopy.$(SUFFIX) sscal.$(SUFFIX) \
		sdot.$(SUFFIX) sdsdot.$(SUFFIX) dsdot.$(SUFFIX) \
		sasum.$(SUFFIX) ssum.$(SUFFIX) snrm2.$(SUFFIX) \
		smax.$(SUFFIX) samax.$(SUFFIX) ismax.$(SUFFIX) isamax.$(SUFFIX) \
		smin.$(SUFFIX) samin.$(SUFFIX) ismin.$(SUFFIX) isamin.$(SUFFIX) \
		srot.$(SUFFIX) srotg.$(SUFFIX) srotm.$(SUFFIX) srotmg.$(SUFFIX) \
		saxpby.$(SUFFIX)

SBLAS2OBJS    = \
		sgemv.$(SUFFIX) sger.$(SUFFIX) \
		strsv.$(SUFFIX) strmv.$(SUFFIX) ssymv.$(SUFFIX) \
		ssyr.$(SUFFIX)  ssyr2.$(SUFFIX) sgbmv.$(SUFFIX) \
		ssbmv.$(SUFFIX) sspmv.$(SUFFIX) \
		sspr.$(SUFFIX)  sspr2.$(SUFFIX) \
		stbsv.$(SUFFIX) stbmv.$(SUFFIX) \
		stpsv.$(SUFFIX) stpmv.$(SUFFIX)

SBLAS3OBJS    = \
		sgemm.$(SUFFIX) ssymm.$(SUFFIX) strmm.$(SUFFIX) \
		strsm.$(SUFFIX) ssyrk.$(SUFFIX) ssyr2k.$(SUFFIX) \
		somatcopy.$(SUFFIX) simatcopy.$(SUFFIX)\
		sgeadd.$(SUFFIX) sgemmt.$(SUFFIX)

ifeq ($(BUILD_BFLOAT16),1)
SBBLAS1OBJS    = sbdot.$(SUFFIX)
SBBLAS2OBJS    = sbgemv.$(SUFFIX)
SBBLAS3OBJS    = sbgemm.$(SUFFIX) sbgemmt.$(SUFFIX)
SBEXTOBJS      = sbstobf16.$(SUFFIX) sbdtobf16.$(SUFFIX) sbf16tos.$(SUFFIX) dbf16tod.$(SUFFIX)
endif

DBLAS1OBJS    = \
		daxpy.$(SUFFIX) dswap.$(SUFFIX) \
		dcopy.$(SUFFIX) dscal.$(SUFFIX) \
		ddot.$(SUFFIX) \
		dasum.$(SUFFIX) dsum.$(SUFFIX) dnrm2.$(SUFFIX) \
		dmax.$(SUFFIX) damax.$(SUFFIX) idmax.$(SUFFIX) idamax.$(SUFFIX) \
		dmin.$(SUFFIX) damin.$(SUFFIX) idmin.$(SUFFIX) idamin.$(SUFFIX) \
		drot.$(SUFFIX) drotg.$(SUFFIX) drotm.$(SUFFIX) drotmg.$(SUFFIX) \
		daxpby.$(SUFFIX)

DBLAS2OBJS    = \
		dgemv.$(SUFFIX) dger.$(SUFFIX) \
		dtrsv.$(SUFFIX) dtrmv.$(SUFFIX) dsymv.$(SUFFIX) \
		dsyr.$(SUFFIX)  dsyr2.$(SUFFIX) dgbmv.$(SUFFIX) \
		dsbmv.$(SUFFIX) dspmv.$(SUFFIX) \
		dspr.$(SUFFIX)  dspr2.$(SUFFIX) \
		dtbsv.$(SUFFIX) dtbmv.$(SUFFIX) \
		dtpsv.$(SUFFIX) dtpmv.$(SUFFIX)

DBLAS3OBJS    = \
		dgemm.$(SUFFIX) dsymm.$(SUFFIX) dtrmm.$(SUFFIX) \
		dtrsm.$(SUFFIX) dsyrk.$(SUFFIX) dsyr2k.$(SUFFIX) \
		domatcopy.$(SUFFIX) dimatcopy.$(SUFFIX)\
		dgeadd.$(SUFFIX) dgemmt.$(SUFFIX)

CBLAS1OBJS    = \
		caxpy.$(SUFFIX) caxpyc.$(SUFFIX) cswap.$(SUFFIX) \
		ccopy.$(SUFFIX) cscal.$(SUFFIX) csscal.$(SUFFIX) \
		cdotc.$(SUFFIX)  cdotu.$(SUFFIX) \
		scasum.$(SUFFIX) scsum.$(SUFFIX) scnrm2.$(SUFFIX) \
		scamax.$(SUFFIX) icamax.$(SUFFIX) \
		scamin.$(SUFFIX) icamin.$(SUFFIX) \
		csrot.$(SUFFIX) crotg.$(SUFFIX) \
		caxpby.$(SUFFIX)

CBLAS2OBJS    = \
		cgemv.$(SUFFIX) cgeru.$(SUFFIX) cgerc.$(SUFFIX) \
		ctrsv.$(SUFFIX) ctrmv.$(SUFFIX) \
		csyr2.$(SUFFIX) cgbmv.$(SUFFIX) \
		csbmv.$(SUFFIX) \
		cspr2.$(SUFFIX) \
		ctbsv.$(SUFFIX) ctbmv.$(SUFFIX) \
		ctpsv.$(SUFFIX) ctpmv.$(SUFFIX) \
		chemv.$(SUFFIX) chbmv.$(SUFFIX) \
		cher.$(SUFFIX)  cher2.$(SUFFIX) \
		chpmv.$(SUFFIX) chpr.$(SUFFIX)  chpr2.$(SUFFIX)

CBLAS3OBJS    = \
		cgemm.$(SUFFIX) csymm.$(SUFFIX) ctrmm.$(SUFFIX) \
		ctrsm.$(SUFFIX) csyrk.$(SUFFIX) csyr2k.$(SUFFIX) \
	       	chemm.$(SUFFIX) cherk.$(SUFFIX) cher2k.$(SUFFIX) \
		comatcopy.$(SUFFIX) cimatcopy.$(SUFFIX)\
		cgeadd.$(SUFFIX) cgemmt.$(SUFFIX)

ZBLAS1OBJS    = \
		zaxpy.$(SUFFIX) zaxpyc.$(SUFFIX) zswap.$(SUFFIX) \
		zcopy.$(SUFFIX) zscal.$(SUFFIX) zdscal.$(SUFFIX) \
		zdotc.$(SUFFIX)  zdotu.$(SUFFIX) \
		dzasum.$(SUFFIX) dzsum.$(SUFFIX) dznrm2.$(SUFFIX) \
		dzamax.$(SUFFIX) izamax.$(SUFFIX) \
		dzamin.$(SUFFIX) izamin.$(SUFFIX) \
		zdrot.$(SUFFIX) zrotg.$(SUFFIX) \
		zaxpby.$(SUFFIX)

ZBLAS2OBJS    = \
		zgemv.$(SUFFIX) zgeru.$(SUFFIX) zgerc.$(SUFFIX) \
		ztrsv.$(SUFFIX) ztrmv.$(SUFFIX) \
		zsyr2.$(SUFFIX) zgbmv.$(SUFFIX) \
		zsbmv.$(SUFFIX) \
		zspr2.$(SUFFIX) \
		ztbsv.$(SUFFIX) ztbmv.$(SUFFIX) \
		ztpsv.$(SUFFIX) ztpmv.$(SUFFIX) \
		zhemv.$(SUFFIX) zhbmv.$(SUFFIX) \
		zher.$(SUFFIX)  zher2.$(SUFFIX) \
		zhpmv.$(SUFFIX) zhpr.$(SUFFIX)  zhpr2.$(SUFFIX)

ZBLAS3OBJS    = \
		zgemm.$(SUFFIX) zsymm.$(SUFFIX) ztrmm.$(SUFFIX) \
		ztrsm.$(SUFFIX) zsyrk.$(SUFFIX) zsyr2k.$(SUFFIX) \
	       	zhemm.$(SUFFIX) zherk.$(SUFFIX) zher2k.$(SUFFIX) \
		zomatcopy.$(SUFFIX) zimatcopy.$(SUFFIX)\
		zgeadd.$(SUFFIX) zgemmt.$(SUFFIX)

ifeq ($(SUPPORT_GEMM3M), 1)

# CBLAS3OBJS   +=  cgemm3m.$(SUFFIX) csymm3m.$(SUFFIX) chemm3m.$(SUFFIX)
CBLAS3OBJS   +=  cgemm3m.$(SUFFIX)

# ZBLAS3OBJS   +=  zgemm3m.$(SUFFIX) zsymm3m.$(SUFFIX) zhemm3m.$(SUFFIX)
ZBLAS3OBJS   +=  zgemm3m.$(SUFFIX)

endif

ifeq ($(EXPRECISION), 1)

QBLAS1OBJS    = \
		qaxpy.$(SUFFIX) qswap.$(SUFFIX) \
		qcopy.$(SUFFIX) qscal.$(SUFFIX) \
		qdot.$(SUFFIX) \
		qasum.$(SUFFIX) qsum.$(SUFFIX) qnrm2.$(SUFFIX) \
		qmax.$(SUFFIX) qamax.$(SUFFIX) iqmax.$(SUFFIX) iqamax.$(SUFFIX) \
		qmin.$(SUFFIX) qamin.$(SUFFIX) iqmin.$(SUFFIX) iqamin.$(SUFFIX) \
		qrot.$(SUFFIX) qrotg.$(SUFFIX) qrotm.$(SUFFIX) qrotmg.$(SUFFIX) \

QBLAS2OBJS    = \
		qgemv.$(SUFFIX) qger.$(SUFFIX) \
		qtrsv.$(SUFFIX) qtrmv.$(SUFFIX) qsymv.$(SUFFIX) \
		qsyr.$(SUFFIX)  qsyr2.$(SUFFIX) qgbmv.$(SUFFIX) \
		qsbmv.$(SUFFIX) qspmv.$(SUFFIX) \
		qspr.$(SUFFIX)  qspr2.$(SUFFIX) \
		qtbsv.$(SUFFIX) qtbmv.$(SUFFIX) \
		qtpsv.$(SUFFIX) qtpmv.$(SUFFIX)

QBLAS3OBJS    = \
		qgemm.$(SUFFIX) qsymm.$(SUFFIX) qtrmm.$(SUFFIX) \
		qtrsm.$(SUFFIX) qsyrk.$(SUFFIX) qsyr2k.$(SUFFIX)

XBLAS1OBJS    = \
		xaxpy.$(SUFFIX) xaxpyc.$(SUFFIX) xswap.$(SUFFIX) \
		xcopy.$(SUFFIX) xscal.$(SUFFIX) xqscal.$(SUFFIX) \
		xdotc.$(SUFFIX)  xdotu.$(SUFFIX) \
		qxasum.$(SUFFIX) qxsum.$(SUFFIX) qxnrm2.$(SUFFIX) \
		qxamax.$(SUFFIX) ixamax.$(SUFFIX) \
		qxamin.$(SUFFIX) ixamin.$(SUFFIX) \
		xqrot.$(SUFFIX) xrotg.$(SUFFIX) \

XBLAS2OBJS    = \
		xgemv.$(SUFFIX) xgeru.$(SUFFIX) xgerc.$(SUFFIX) \
		xtrsv.$(SUFFIX) xtrmv.$(SUFFIX) xsymv.$(SUFFIX) \
		xsyr.$(SUFFIX)  xsyr2.$(SUFFIX) xgbmv.$(SUFFIX) \
		xsbmv.$(SUFFIX) xspmv.$(SUFFIX) \
		xspr.$(SUFFIX)  xspr2.$(SUFFIX) \
		xtbsv.$(SUFFIX) xtbmv.$(SUFFIX) \
		xtpsv.$(SUFFIX) xtpmv.$(SUFFIX) \
		xhemv.$(SUFFIX) xhbmv.$(SUFFIX) \
		xher.$(SUFFIX)  xher2.$(SUFFIX) \
		xhpmv.$(SUFFIX) xhpr.$(SUFFIX)  xhpr2.$(SUFFIX)

XBLAS3OBJS    = \
		xgemm.$(SUFFIX) xsymm.$(SUFFIX) xtrmm.$(SUFFIX) \
		xtrsm.$(SUFFIX) xsyrk.$(SUFFIX) xsyr2k.$(SUFFIX) \
		xhemm.$(SUFFIX) xherk.$(SUFFIX) xher2k.$(SUFFIX)

ifeq ($(SUPPORT_GEMM3M), 1)

XBLAS3OBJS   +=  xgemm3m.$(SUFFIX) xsymm3m.$(SUFFIX) xhemm3m.$(SUFFIX)

endif

endif

ifdef QUAD_PRECISION

QBLAS1OBJS    = \
		qaxpy.$(SUFFIX) qswap.$(SUFFIX) \
		qcopy.$(SUFFIX) qscal.$(SUFFIX) \
		qasum.$(SUFFIX) qsum.$(SUFFIX) qnrm2.$(SUFFIX) \
		qmax.$(SUFFIX) qamax.$(SUFFIX) iqmax.$(SUFFIX) iqamax.$(SUFFIX) \
		qmin.$(SUFFIX) qamin.$(SUFFIX) iqmin.$(SUFFIX) iqamin.$(SUFFIX) \
		qrot.$(SUFFIX) qrotg.$(SUFFIX) qrotm.$(SUFFIX) qrotmg.$(SUFFIX) \

QBLAS2OBJS    = \
		qgemv.$(SUFFIX) qger.$(SUFFIX) \
		qtrsv.$(SUFFIX) qtrmv.$(SUFFIX) qsymv.$(SUFFIX) \
		qsyr.$(SUFFIX)  qsyr2.$(SUFFIX) qgbmv.$(SUFFIX) \
		qsbmv.$(SUFFIX) qspmv.$(SUFFIX) \
		qspr.$(SUFFIX)  qspr2.$(SUFFIX) \
		qtbsv.$(SUFFIX) qtbmv.$(SUFFIX) \
		qtpsv.$(SUFFIX) qtpmv.$(SUFFIX)

QBLAS3OBJS    = \
		qgemm.$(SUFFIX) qsymm.$(SUFFIX) qtrmm.$(SUFFIX) \
		qtrsm.$(SUFFIX) qsyrk.$(SUFFIX) qsyr2k.$(SUFFIX)

XBLAS1OBJS    = \
		xaxpy.$(SUFFIX) xaxpyc.$(SUFFIX) xswap.$(SUFFIX) \
		xcopy.$(SUFFIX) xscal.$(SUFFIX) xqscal.$(SUFFIX) \
		qxasum.$(SUFFIX) qxsum.$(SUFFIX) qxnrm2.$(SUFFIX) \
		qxamax.$(SUFFIX) ixamax.$(SUFFIX) \
		qxamin.$(SUFFIX) ixamin.$(SUFFIX) \
		xqrot.$(SUFFIX) xrotg.$(SUFFIX) \

XBLAS2OBJS    = \
		xgemv.$(SUFFIX) xgeru.$(SUFFIX) xgerc.$(SUFFIX) \
		xtrsv.$(SUFFIX) xtrmv.$(SUFFIX) xsymv.$(SUFFIX) \
		xsyr.$(SUFFIX)  xsyr2.$(SUFFIX) xgbmv.$(SUFFIX) \
		xsbmv.$(SUFFIX) xspmv.$(SUFFIX) \
		xspr.$(SUFFIX)  xspr2.$(SUFFIX) \
		xtbsv.$(SUFFIX) xtbmv.$(SUFFIX) \
		xtpsv.$(SUFFIX) xtpmv.$(SUFFIX) \
		xhemv.$(SUFFIX) xhbmv.$(SUFFIX) \
		xher.$(SUFFIX)  xher2.$(SUFFIX) \
		xhpmv.$(SUFFIX) xhpr.$(SUFFIX)  xhpr2.$(SUFFIX)

XBLAS3OBJS    = \
		xgemm.$(SUFFIX) xsymm.$(SUFFIX) xtrmm.$(SUFFIX) \
		xtrsm.$(SUFFIX) xsyrk.$(SUFFIX) xsyr2k.$(SUFFIX) \
		xhemm.$(SUFFIX) xherk.$(SUFFIX) xher2k.$(SUFFIX)

ifeq ($(SUPPORT_GEMM3M), 1)

XBLAS3OBJS   +=  xgemm3m.$(SUFFIX) xsymm3m.$(SUFFIX) xhemm3m.$(SUFFIX)

endif
endif

endif

HPLOBJS = dgemm.$(SUFFIX) dtrsm.$(SUFFIX) \
	  dgemv.$(SUFFIX)  dtrsv.$(SUFFIX) dger.$(SUFFIX) \
	  idamax.$(SUFFIX) daxpy.$(SUFFIX) dcopy.$(SUFFIX) dscal.$(SUFFIX)

CSBLAS1OBJS   = \
	cblas_isamax.$(SUFFIX) cblas_isamin.$(SUFFIX) cblas_sasum.$(SUFFIX) cblas_saxpy.$(SUFFIX) \
	cblas_scopy.$(SUFFIX) cblas_sdot.$(SUFFIX) cblas_sdsdot.$(SUFFIX) cblas_dsdot.$(SUFFIX) \
	cblas_srot.$(SUFFIX) cblas_srotg.$(SUFFIX) cblas_srotm.$(SUFFIX) cblas_srotmg.$(SUFFIX) \
	cblas_sscal.$(SUFFIX) cblas_sswap.$(SUFFIX) cblas_snrm2.$(SUFFIX) cblas_saxpby.$(SUFFIX) \
	cblas_ismin.$(SUFFIX) cblas_ismax.$(SUFFIX) cblas_ssum.$(SUFFIX) cblas_samax.$(SUFFIX) \
	cblas_samin.$(SUFFIX)

CSBLAS2OBJS   = \
	cblas_sgemv.$(SUFFIX) cblas_sger.$(SUFFIX) cblas_ssymv.$(SUFFIX) cblas_strmv.$(SUFFIX) \
	cblas_strsv.$(SUFFIX) cblas_ssyr.$(SUFFIX) cblas_ssyr2.$(SUFFIX) cblas_sgbmv.$(SUFFIX) \
	cblas_ssbmv.$(SUFFIX) cblas_sspmv.$(SUFFIX) cblas_sspr.$(SUFFIX) cblas_sspr2.$(SUFFIX) \
	cblas_stbmv.$(SUFFIX) cblas_stbsv.$(SUFFIX) cblas_stpmv.$(SUFFIX) cblas_stpsv.$(SUFFIX)

CSBLAS3OBJS   = \
	cblas_sgemm.$(SUFFIX) cblas_ssymm.$(SUFFIX) cblas_strmm.$(SUFFIX) cblas_strsm.$(SUFFIX) \
	cblas_ssyrk.$(SUFFIX) cblas_ssyr2k.$(SUFFIX) cblas_somatcopy.$(SUFFIX)  cblas_simatcopy.$(SUFFIX)\
	cblas_sgeadd.$(SUFFIX) cblas_sgemmt.$(SUFFIX) cblas_sgemm_batch.$(SUFFIX)

ifeq ($(BUILD_BFLOAT16),1)
CSBBLAS1OBJS = cblas_sbdot.$(SUFFIX)
CSBBLAS2OBJS = cblas_sbgemv.$(SUFFIX)
CSBBLAS3OBJS = cblas_sbgemm.$(SUFFIX) cblas_sbgemmt.$(SUFFIX) cblas_sbgemm_batch.$(SUFFIX)
CSBEXTOBJS   = cblas_sbstobf16.$(SUFFIX) cblas_sbdtobf16.$(SUFFIX) cblas_sbf16tos.$(SUFFIX) cblas_dbf16tod.$(SUFFIX)
endif

CDBLAS1OBJS   = \
	cblas_idamax.$(SUFFIX) cblas_idamin.$(SUFFIX) cblas_dasum.$(SUFFIX) cblas_daxpy.$(SUFFIX) \
	cblas_dcopy.$(SUFFIX) cblas_ddot.$(SUFFIX) \
	cblas_drot.$(SUFFIX) cblas_drotg.$(SUFFIX) cblas_drotm.$(SUFFIX) cblas_drotmg.$(SUFFIX) \
	cblas_dscal.$(SUFFIX) cblas_dswap.$(SUFFIX) cblas_dnrm2.$(SUFFIX) cblas_daxpby.$(SUFFIX) \
	cblas_idmin.$(SUFFIX) cblas_idmax.$(SUFFIX) cblas_dsum.$(SUFFIX) cblas_damax.$(SUFFIX) \
	cblas_damin.$(SUFFIX)

CDBLAS2OBJS   = \
	cblas_dgemv.$(SUFFIX) cblas_dger.$(SUFFIX) cblas_dsymv.$(SUFFIX) cblas_dtrmv.$(SUFFIX) \
	cblas_dtrsv.$(SUFFIX) cblas_dsyr.$(SUFFIX) cblas_dsyr2.$(SUFFIX) cblas_dgbmv.$(SUFFIX) \
	cblas_dsbmv.$(SUFFIX) cblas_dspmv.$(SUFFIX) cblas_dspr.$(SUFFIX) cblas_dspr2.$(SUFFIX) \
	cblas_dtbmv.$(SUFFIX) cblas_dtbsv.$(SUFFIX) cblas_dtpmv.$(SUFFIX) cblas_dtpsv.$(SUFFIX)

CDBLAS3OBJS   += \
	cblas_dgemm.$(SUFFIX) cblas_dsymm.$(SUFFIX) cblas_dtrmm.$(SUFFIX) cblas_dtrsm.$(SUFFIX) \
	cblas_dsyrk.$(SUFFIX) cblas_dsyr2k.$(SUFFIX) cblas_domatcopy.$(SUFFIX)  cblas_dimatcopy.$(SUFFIX) \
        cblas_dgeadd.$(SUFFIX) cblas_dgemmt.$(SUFFIX) cblas_dgemm_batch.$(SUFFIX)

CCBLAS1OBJS   = \
	cblas_icamax.$(SUFFIX) cblas_icamin.$(SUFFIX) cblas_scasum.$(SUFFIX)  cblas_caxpy.$(SUFFIX) \
	cblas_ccopy.$(SUFFIX) \
	cblas_cdotc.$(SUFFIX) cblas_cdotu.$(SUFFIX) \
	cblas_cdotc_sub.$(SUFFIX) cblas_cdotu_sub.$(SUFFIX) \
	cblas_cscal.$(SUFFIX) cblas_csscal.$(SUFFIX) \
	cblas_cswap.$(SUFFIX) cblas_scnrm2.$(SUFFIX) \
	cblas_caxpby.$(SUFFIX) cblas_scamax.$(SUFFIX) cblas_caxpyc.$(SUFFIX) cblas_scamin.$(SUFFIX) \
	cblas_icmin.$(SUFFIX) cblas_icmax.$(SUFFIX) cblas_scsum.$(SUFFIX) cblas_csrot.$(SUFFIX) cblas_crotg.$(SUFFIX)

CCBLAS2OBJS   = \
	cblas_cgemv.$(SUFFIX) cblas_cgerc.$(SUFFIX) cblas_cgeru.$(SUFFIX) \
	cblas_cgbmv.$(SUFFIX) cblas_chbmv.$(SUFFIX) cblas_chemv.$(SUFFIX) \
	cblas_cher.$(SUFFIX) cblas_cher2.$(SUFFIX) cblas_chpmv.$(SUFFIX) \
	cblas_chpr.$(SUFFIX) cblas_chpr2.$(SUFFIX) cblas_ctbmv.$(SUFFIX) \
	cblas_ctbsv.$(SUFFIX) cblas_ctpmv.$(SUFFIX) cblas_ctpsv.$(SUFFIX) \
	cblas_ctrmv.$(SUFFIX) cblas_ctrsv.$(SUFFIX)

CCBLAS3OBJS   = \

=== test/Makefile ===
TOPDIR	= ..
include ../Makefile.system
ifeq ($(F_COMPILER),GFORTRAN)
ifneq (, $(filter $(CORE),LOONGSON3R3 LOONGSON3R4))
	override FFLAGS = $(filter_out(-O2 -O3,$(FFLAGS))) -O0
endif
        override FFLAGS += -fno-tree-vectorize
endif

SUPPORT_GEMM3M = 0

ifeq ($(ARCH), x86)
SUPPORT_GEMM3M = 1
endif

ifeq ($(ARCH), x86_64)
SUPPORT_GEMM3M = 1
endif

ifeq ($(ARCH), ia64)
SUPPORT_GEMM3M = 1
endif

ifeq ($(ARCH), MIPS)
SUPPORT_GEMM3M = 1
endif

ifeq ($(NOFORTRAN),1)
all ::
else
all :: level1 level2 level3
endif

ifeq ($(BUILD_SINGLE),1)
S1=sblat1
endif
ifeq ($(BUILD_DOUBLE),1)
D1=dblat1
endif
ifeq ($(BUILD_COMPLEX),1)
C1=cblat1
endif
ifeq ($(BUILD_COMPLEX16),1)
Z1=zblat1
endif

level1: $(S1) $(D1) $(C1) $(Z1)

ifneq ($(CROSS), 1)
ifeq ($(BUILD_SINGLE),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./sblat1
endif
ifeq ($(BUILD_DOUBLE),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./dblat1
endif
ifeq ($(BUILD_COMPLEX),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./cblat1
endif
ifeq ($(BUILD_COMPLEX16),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./zblat1
endif
ifdef SMP
ifeq ($(USE_OPENMP), 1)
ifeq ($(BUILD_SINGLE),1)
	OMP_NUM_THREADS=2 ./sblat1
endif
ifeq ($(BUILD_DOUBLE),1)
	OMP_NUM_THREADS=2 ./dblat1
endif
ifeq ($(BUILD_COMPLEX),1)
	OMP_NUM_THREADS=2 ./cblat1
endif
ifeq ($(BUILD_COMPLEX16),1)
	OMP_NUM_THREADS=2 ./zblat1
endif
else
ifeq ($(BUILD_SINGLE),1)
	OPENBLAS_NUM_THREADS=2 ./sblat1
endif
ifeq ($(BUILD_DOUBLE),1)
	OPENBLAS_NUM_THREADS=2 ./dblat1
endif
ifeq ($(BUILD_COMPLEX),1)
	OPENBLAS_NUM_THREADS=2 ./cblat1
endif
ifeq ($(BUILD_COMPLEX16),1)
	OPENBLAS_NUM_THREADS=2 ./zblat1
endif
endif
endif
endif

ifeq ($(BUILD_SINGLE),1)
S2=sblat2
endif
ifeq ($(BUILD_DOUBLE),1)
D2=dblat2
endif
ifeq ($(BUILD_COMPLEX),1)
C2=cblat2
endif
ifeq ($(BUILD_COMPLEX16),1)
Z2=zblat2
endif

level2: $(S2) $(D2) $(C2) $(Z2)


ifneq ($(CROSS), 1)
	rm -f ?BLAT2.SUMM
ifeq ($(BUILD_SINGLE),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./sblat2 < ./sblat2.dat
	@$(GREP) -q FATAL SBLAT2.SUMM && cat SBLAT2.SUMM || exit 0
endif
ifeq ($(BUILD_DOUBLE),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./dblat2 < ./dblat2.dat
	@$(GREP) -q FATAL DBLAT2.SUMM && cat DBLAT2.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./cblat2 < ./cblat2.dat
	@$(GREP) -q FATAL CBLAT2.SUMM && cat CBLAT2.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX16),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./zblat2 < ./zblat2.dat
	@$(GREP) -q FATAL ZBLAT2.SUMM && cat ZBLAT2.SUMM || exit 0
endif
ifdef SMP
	rm -f ?BLAT2.SUMM
ifeq ($(USE_OPENMP), 1)
ifeq ($(BUILD_SINGLE),1)
	OMP_NUM_THREADS=2 ./sblat2 < ./sblat2.dat
	@$(GREP) -q FATAL SBLAT2.SUMM && cat SBLAT2.SUMM || exit 0
endif
ifeq ($(BUILD_DOUBLE),1)
	OMP_NUM_THREADS=2 ./dblat2 < ./dblat2.dat
	@$(GREP) -q FATAL DBLAT2.SUMM && cat DBLAT2.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX),1)
	OMP_NUM_THREADS=2 ./cblat2 < ./cblat2.dat
	@$(GREP) -q FATAL CBLAT2.SUMM && cat CBLAT2.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX16),1)
	OMP_NUM_THREADS=2 ./zblat2 < ./zblat2.dat
	@$(GREP) -q FATAL ZBLAT2.SUMM && cat ZBLAT2.SUMM || exit 0
endif
else
ifeq ($(BUILD_SINGLE),1)
	OPENBLAS_NUM_THREADS=2 ./sblat2 < ./sblat2.dat
	@$(GREP) -q FATAL SBLAT2.SUMM && cat SBLAT2.SUMM || exit 0
endif
ifeq ($(BUILD_DOUBLE),1)
	OPENBLAS_NUM_THREADS=2 ./dblat2 < ./dblat2.dat
	@$(GREP) -q FATAL DBLAT2.SUMM && cat DBLAT2.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX),1)
	OPENBLAS_NUM_THREADS=2 ./cblat2 < ./cblat2.dat
	@$(GREP) -q FATAL CBLAT2.SUMM && cat CBLAT2.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX16),1)
	OPENBLAS_NUM_THREADS=2 ./zblat2 < ./zblat2.dat
	@$(GREP) -q FATAL ZBLAT2.SUMM && cat ZBLAT2.SUMM || exit 0
endif
endif
endif
endif

ifeq ($(BUILD_BFLOAT16),1)
B3= test_sbgemm
endif
ifeq ($(BUILD_SINGLE),1)
S3=sblat3
endif
ifeq ($(BUILD_DOUBLE),1)
D3=dblat3
endif
ifeq ($(BUILD_COMPLEX),1)
ifeq ($(SUPPORT_GEMM3M),1)
C3=cblat3 cblat3_3m
else
C3=cblat3
endif
endif
ifeq ($(BUILD_COMPLEX16),1)
ifeq ($(SUPPORT_GEMM3M),1)
Z3=zblat3 zblat3_3m
else
Z3=zblat3
endif
endif


ifeq ($(SUPPORT_GEMM3M),1)
level3: $(B3) $(S3) $(D3) $(C3) $(Z3) level3_3m
else
level3: $(B3) $(S3) $(D3) $(C3) $(Z3)
endif

ifneq ($(CROSS), 1)
	rm -f ?BLAT3.SUMM
ifeq ($(BUILD_BFLOAT16),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./test_sbgemm > SBBLAT3.SUMM
	@$(GREP) -q FATAL SBBLAT3.SUMM && cat SBBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_SINGLE),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./sblat3 < ./sblat3.dat
	@$(GREP) -q FATAL SBLAT3.SUMM && cat SBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_DOUBLE),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./dblat3 < ./dblat3.dat
	@$(GREP) -q FATAL DBLAT3.SUMM && cat DBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./cblat3 < ./cblat3.dat
	@$(GREP) -q FATAL CBLAT3.SUMM && cat CBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX16),1)
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./zblat3 < ./zblat3.dat
	@$(GREP) -q FATAL ZBLAT3.SUMM && cat ZBLAT3.SUMM || exit 0
endif
ifdef SMP
	rm -f ?BLAT3.SUMM
ifeq ($(USE_OPENMP), 1)
ifeq ($(BUILD_BFLOAT16),1)
	OMP_NUM_THREADS=2 ./test_sbgemm > SBBLAT3.SUMM
	@$(GREP) -q FATAL SBBLAT3.SUMM && cat SBBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_SINGLE),1)
	OMP_NUM_THREADS=2 ./sblat3 < ./sblat3.dat
	@$(GREP) -q FATAL SBLAT3.SUMM && cat SBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_DOUBLE),1)
	OMP_NUM_THREADS=2 ./dblat3 < ./dblat3.dat
	@$(GREP) -q FATAL DBLAT3.SUMM && cat DBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX),1)
	OMP_NUM_THREADS=2 ./cblat3 < ./cblat3.dat
	@$(GREP) -q FATAL CBLAT3.SUMM && cat CBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX16),1)
	OMP_NUM_THREADS=2 ./zblat3 < ./zblat3.dat
	@$(GREP) -q FATAL ZBLAT3.SUMM && cat ZBLAT3.SUMM || exit 0
endif
else
ifeq ($(BUILD_BFLOAT16),1)
	OPENBLAS_NUM_THREADS=2 ./test_sbgemm > SBBLAT3.SUMM
	@$(GREP) -q FATAL SBBLAT3.SUMM && cat SBBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_SINGLE),1)
	OPENBLAS_NUM_THREADS=2 ./sblat3 < ./sblat3.dat
	@$(GREP) -q FATAL SBLAT3.SUMM && cat SBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_DOUBLE),1)
	OPENBLAS_NUM_THREADS=2 ./dblat3 < ./dblat3.dat
	@$(GREP) -q FATAL DBLAT3.SUMM && cat DBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX),1)
	OPENBLAS_NUM_THREADS=2 ./cblat3 < ./cblat3.dat
	@$(GREP) -q FATAL CBLAT3.SUMM && cat CBLAT3.SUMM || exit 0
endif
ifeq ($(BUILD_COMPLEX16),1)
	OPENBLAS_NUM_THREADS=2 ./zblat3 < ./zblat3.dat
	@$(GREP) -q FATAL ZBLAT3.SUMM && cat ZBLAT3.SUMM || exit 0
endif
endif
endif
endif


level3_3m: zblat3_3m cblat3_3m
ifneq ($(CROSS), 1)
	rm -f ?BLAT3_3M.SUMM
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./cblat3_3m < ./cblat3_3m.dat
	@$(GREP) -q FATAL CBLAT3_3M.SUMM && cat CBLAT3_3M.SUMM || exit 0
	OPENBLAS_NUM_THREADS=1 OMP_NUM_THREADS=1 ./zblat3_3m < ./zblat3_3m.dat
	@$(GREP) -q FATAL ZBLAT3_3M.SUMM && cat ZBLAT3_3M.SUMM || exit 0
ifdef SMP
	rm -f ?BLAT3_3M.SUMM
ifeq ($(USE_OPENMP), 1)
	OMP_NUM_THREADS=2 ./cblat3_3m < ./cblat3_3m.dat
	@$(GREP) -q FATAL CBLAT3_3M.SUMM && cat CBLAT3_3M.SUMM || exit 0
	OMP_NUM_THREADS=2 ./zblat3_3m < ./zblat3_3m.dat
	@$(GREP) -q FATAL ZBLAT3_3M.SUMM && cat ZBLAT3_3M.SUMM || exit 0
else
	OPENBLAS_NUM_THREADS=2 ./cblat3_3m < ./cblat3_3m.dat
	@$(GREP) -q FATAL CBLAT3_3M.SUMM && cat CBLAT3_3M.SUMM || exit 0
	OPENBLAS_NUM_THREADS=2 ./zblat3_3m < ./zblat3_3m.dat
	@$(GREP) -q FATAL ZBLAT3_3M.SUMM && cat ZBLAT3_3M.SUMM || exit 0
endif
endif
endif




FLDFLAGS = $(FFLAGS:-fPIC=) $(LDFLAGS)
CLDFLAGS = $(CFLAGS) $(LDFLAGS)


ifeq ($(USE_OPENMP), 1)
ifeq ($(F_COMPILER), GFORTRAN)
ifeq ($(C_COMPILER), CLANG)
CEXTRALIB += -lomp
endif
endif
ifeq ($(F_COMPILER), NAG)
CEXTRALIB = -lgomp
endif
ifeq ($(F_COMPILER), IBM)
ifeq ($(C_COMPILER), GCC)
CEXTRALIB += -lgomp
endif
ifeq ($(C_COMPILER), CLANG)
CEXTRALIB += -lomp
endif
endif
endif

ifeq ($(BUILD_SINGLE),1)
sblat1 : sblat1.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o sblat1 sblat1.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)

sblat2 : sblat2.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o sblat2 sblat2.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)

sblat3 : sblat3.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o sblat3 sblat3.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)
endif

ifeq ($(BUILD_DOUBLE),1)
dblat1 : dblat1.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o dblat1 dblat1.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)

dblat2 : dblat2.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o dblat2 dblat2.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)

dblat3 : dblat3.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o dblat3 dblat3.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)
else
dblat2:
dblat3:
endif


qblat1 : qblat1.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o qblat1 qblat1.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)

ifeq ($(BUILD_COMPLEX),1)
cblat1 : cblat1.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o cblat1 cblat1.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)

cblat2 : cblat2.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o cblat2 cblat2.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)

cblat3 : cblat3.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o cblat3 cblat3.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)
endif

ifeq ($(BUILD_COMPLEX16),1)
zblat1 : zblat1.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o zblat1 zblat1.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)

zblat2 : zblat2.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o zblat2 zblat2.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)

zblat3 : zblat3.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o zblat3 zblat3.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)
endif

ifeq ($(BUILD_BFLOAT16),1)
test_sbgemm : compare_sgemm_sbgemm.c ../$(LIBNAME)
	$(CC) $(CLDFLAGS) -o test_sbgemm compare_sgemm_sbgemm.c ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)
endif

ifeq ($(BUILD_COMPLEX),1)
cblat3_3m : cblat3_3m.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o cblat3_3m cblat3_3m.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)
endif

ifeq ($(BUILD_COMPLEX16),1)
zblat3_3m : zblat3_3m.$(SUFFIX) ../$(LIBNAME)
	$(FC) $(FLDFLAGS) -o zblat3_3m zblat3_3m.$(SUFFIX) ../$(LIBNAME) $(EXTRALIB) $(CEXTRALIB)
endif



clean:
	@rm -f *.$(SUFFIX) *.$(PSUFFIX) gmon.$(SUFFIX)ut *.SUMM *.cxml *.exe *.pdb *.dwf \
	sblat1 dblat1 cblat1 zblat1 \
	sblat2 dblat2 cblat2 zblat2 \
	test_sbgemm sblat3 dblat3 cblat3 zblat3 \
	sblat1p dblat1p cblat1p zblat1p \
	sblat2p dblat2p cblat2p zblat2p \
	sblat3p dblat3p cblat3p zblat3p \
	zblat3_3m zblat3_3mp \
	cblat3_3m cblat3_3mp \
	*.stackdump *.dll

libs:

prof:

quick :
	$(MAKE) -C $(TOPDIR) libs

# include ../Makefile.tail

=== driver/others/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_BINARY_DIR})

if (${CORE} STREQUAL "PPC440")
  set(MEMORY memory_qalloc.c)
else ()
  set(MEMORY memory.c)
endif ()

if (USE_THREAD)

  if (USE_OPENMP)
    set(BLAS_SERVER blas_server_omp.c)
  elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    set(BLAS_SERVER blas_server_win32.c)
  elseif (${CMAKE_SYSTEM_NAME} STREQUAL "WindowsStore")
    set(BLAS_SERVER blas_server_win32.c)
  endif ()

  if (NOT DEFINED BLAS_SERVER)
    set(BLAS_SERVER blas_server.c)
  endif ()

  set(SMP_SOURCES
    ${BLAS_SERVER}
    divtable.c # TODO: Makefile has -UDOUBLE
    blas_l1_thread.c
    blas_server_callback.c
  )

  if (NOT NO_AFFINITY)
    list(APPEND SMP_SOURCES init.c)
  endif ()
endif ()

set(COMMON_SOURCES
  xerbla.c
  openblas_set_num_threads.c
  openblas_error_handle.c
  openblas_env.c
  openblas_get_num_procs.c
  openblas_get_num_threads.c
)

# these need to have NAME/CNAME set, so use GenerateNamedObjects, but don't use standard name mangling
GenerateNamedObjects("abs.c" "" "c_abs" 0 "" "" 1 )
GenerateNamedObjects("abs.c" "DOUBLE" "z_abs" 0 "" "" 1)
GenerateNamedObjects("openblas_get_config.c;openblas_get_parallel.c" "" "" 0 "" "" 1)

if (DYNAMIC_ARCH)
  if (ARM64)
    list(APPEND COMMON_SOURCES dynamic_arm64.c)
  elseif (POWER)
    list(APPEND COMMON_SOURCES dynamic_power.c)
  elseif (RISCV64)
    list(APPEND COMMON_SOURCES dynamic_riscv64.c detect_riscv64.c)
  else ()  
    list(APPEND COMMON_SOURCES dynamic.c)
  endif ()  
else ()
  list(APPEND COMMON_SOURCES parameter.c)
endif ()

#ifdef EXPRECISION
#COMMONOBJS	+= x_abs.$(SUFFIX) qlamch.$(SUFFIX) qlamc3.$(SUFFIX)
#endif
#
#ifdef QUAD_PRECISION
#COMMONOBJS	+= addx.$(SUFFIX) mulx.$(SUFFIX)
#endif
#
#ifdef USE_CUDA
#COMMONOBJS	+= cuda_init.$(SUFFIX)
#endif
#
#ifdef FUNCTION_PROFILE
#COMMONOBJS	+= profile.$(SUFFIX)
#endif

#LIBOTHERS = libothers.$(LIBSUFFIX)

#ifeq ($(DYNAMIC_ARCH), 1)
#HPLOBJS = memory.$(SUFFIX) xerbla.$(SUFFIX) dynamic.$(SUFFIX)
#else
#HPLOBJS = memory.$(SUFFIX) xerbla.$(SUFFIX) parameter.$(SUFFIX)
#endif

add_library(driver_others OBJECT ${OPENBLAS_SRC} ${MEMORY} ${SMP_SOURCES} ${COMMON_SOURCES})

=== relapack/src/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR})
include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}/relapack)

set(RELAFILES
clauum.c
ctrsyl_rec2.c
dsytrf.c
spbtrf.c
strsyl_rec2.c
zhetrf_rook_rec2.c
ztrsyl.c
cgbtrf.c
cpbtrf.c
ctrtri.c
dsytrf_rec2.c
spotrf.c
strtri.c
zlauum.c
ztrsyl_rec2.c
cgemmt.c
cpotrf.c
dgbtrf.c
dsytrf_rook.c
lapack_wrappers.c
ssygst.c
zgbtrf.c
zpbtrf.c
ztrtri.c
cgetrf.c
csytrf.c
dgemmt.c
dsytrf_rook_rec2.c
ssytrf.c
zgemmt.c
zpotrf.c
chegst.c
csytrf_rec2.c
dgetrf.c
dtgsyl.c
ssytrf_rec2.c
zgetrf.c
zsytrf.c
chetrf.c
csytrf_rook.c
dlauum.c
dtrsyl.c
sgbtrf.c
ssytrf_rook.c
zhegst.c
zsytrf_rec2.c
chetrf_rec2.c
csytrf_rook_rec2.c
dpbtrf.c
dtrsyl_rec2.c
sgemmt.c
ssytrf_rook_rec2.c
zhetrf.c
zsytrf_rook.c
chetrf_rook.c
ctgsyl.c
dpotrf.c
dtrtri.c
sgetrf.c
stgsyl.c
zhetrf_rec2.c
zsytrf_rook_rec2.c
chetrf_rook_rec2.c
ctrsyl.c
dsygst.c
f2c.c
slauum.c
strsyl.c
zhetrf_rook.c
ztgsyl.c
)



# add relapack folder to the sources
set(RELA_SOURCES "")
foreach (RELA_FILE ${RELAFILES})
  list(APPEND RELA_SOURCES "${PROJECT_SOURCE_DIR}/relapack/src/${RELA_FILE}")
endforeach ()
add_library(relapack_src OBJECT ${RELA_SOURCES})
set_source_files_properties(${RELA_SOURCES} PROPERTIES COMPILE_FLAGS "${LAPACK_CFLAGS}")

=== lapack-netlib/TESTING/EIG/CMakeLists.txt ===
########################################################################
#  This is the makefile for the eigenvalue test program from LAPACK.
#  The test files are organized as follows:
#
#     AEIGTST -- Auxiliary test routines used in all precisions
#     SCIGTST -- Auxiliary test routines used in single precision
#     DZIGTST -- Auxiliary test routines used in double precision
#     SEIGTST -- Single precision real test routines
#     CEIGTST -- Single precision complex test routines
#     DEIGTST -- Double precision real test routines
#     ZEIGTST -- Double precision complex test routines
#
########################################################################

set(AEIGTST
   alahdg.f
   alasum.f
   alasvm.f
   alareq.f
   ilaenv.f
   xerbla.f
   xlaenv.f
   chkxer.f)

set(SCIGTST slafts.f slahd2.f slasum.f slatb9.f sstech.f sstect.f
   ssvdch.f ssvdct.f ssxt1.f)

set(SEIGTST schkee.F
   sbdt01.f sbdt02.f sbdt03.f sbdt04.f sbdt05.f
   schkbb.f schkbd.f schkbk.f schkbl.f schkec.f
   schkgg.f schkgk.f schkgl.f schkhs.f schksb.f schkst.f schkst2stg.f schksb2stg.f
   sckcsd.f sckglm.f sckgqr.f sckgsv.f scklse.f scsdts.f
   sdrges.f sdrgev.f sdrges3.f sdrgev3.f sdrgsx.f sdrgvx.f
   sdrvbd.f sdrves.f sdrvev.f sdrvsg.f sdrvsg2stg.f
   sdrvst.f sdrvst2stg.f sdrvsx.f sdrvvx.f
   serrbd.f serrec.f serred.f serrgg.f serrhs.f serrst.f
   sget02.f sget10.f sget22.f sget23.f sget24.f sget31.f
   sget32.f sget33.f sget34.f sget35.f sget36.f
   sget37.f sget38.f sget39.f sget40.f sget51.f sget52.f sget53.f
   sget54.f sglmts.f sgqrts.f sgrqts.f sgsvts3.f
   shst01.f slarfy.f slarhs.f slatm4.f slctes.f slctsx.f slsets.f sort01.f
   sort03.f ssbt21.f ssgt01.f sslect.f sspt21.f sstt21.f
   sstt22.f ssyl01.f ssyt21.f ssyt22.f)

set(SDMDEIGTST schkdmd.f90)

set(CEIGTST cchkee.F
   cbdt01.f cbdt02.f cbdt03.f cbdt05.f
   cchkbb.f cchkbd.f cchkbk.f cchkbl.f cchkec.f
   cchkgg.f cchkgk.f cchkgl.f cchkhb.f cchkhs.f cchkst.f cchkst2stg.f cchkhb2stg.f
   cckcsd.f cckglm.f cckgqr.f cckgsv.f ccklse.f ccsdts.f
   cdrges.f cdrgev.f cdrges3.f cdrgev3.f cdrgsx.f cdrgvx.f
   cdrvbd.f cdrves.f cdrvev.f cdrvsg.f cdrvsg2stg.f
   cdrvst.f cdrvst2stg.f cdrvsx.f cdrvvx.f
   cerrbd.f cerrec.f cerred.f cerrgg.f cerrhs.f cerrst.f
   cget02.f cget10.f cget22.f cget23.f cget24.f
   cget35.f cget36.f cget37.f cget38.f cget51.f cget52.f
   cget54.f cglmts.f cgqrts.f cgrqts.f cgsvts3.f
   chbt21.f chet21.f chet22.f chpt21.f chst01.f
   clarfy.f clarhs.f clatm4.f clctes.f clctsx.f clsets.f csbmv.f
   csgt01.f cslect.f csyl01.f
   cstt21.f cstt22.f cunt01.f cunt03.f)

set(CDMDEIGTST cchkdmd.f90)

set(DZIGTST dlafts.f dlahd2.f dlasum.f dlatb9.f dstech.f dstect.f
   dsvdch.f dsvdct.f dsxt1.f)

set(DEIGTST dchkee.F
   dbdt01.f dbdt02.f dbdt03.f dbdt04.f dbdt05.f
   dchkbb.f dchkbd.f dchkbk.f dchkbl.f dchkec.f
   dchkgg.f dchkgk.f dchkgl.f dchkhs.f dchksb.f dchkst.f dchkst2stg.f dchksb2stg.f
   dckcsd.f dckglm.f dckgqr.f dckgsv.f dcklse.f dcsdts.f
   ddrges.f ddrgev.f ddrges3.f ddrgev3.f ddrgsx.f ddrgvx.f
   ddrvbd.f ddrves.f ddrvev.f ddrvsg.f ddrvsg2stg.f
   ddrvst.f ddrvst2stg.f ddrvsx.f ddrvvx.f
   derrbd.f derrec.f derred.f derrgg.f derrhs.f derrst.f
   dget02.f dget10.f dget22.f dget23.f dget24.f dget31.f
   dget32.f dget33.f dget34.f dget35.f dget36.f
   dget37.f dget38.f dget39.f dget40.f dget51.f dget52.f dget53.f
   dget54.f dglmts.f dgqrts.f dgrqts.f dgsvts3.f
   dhst01.f dlarfy.f dlarhs.f dlatm4.f dlctes.f dlctsx.f dlsets.f dort01.f
   dort03.f dsbt21.f dsgt01.f dslect.f dspt21.f dstt21.f
   dstt22.f dsyl01.f dsyt21.f dsyt22.f)

set(DDMDEIGTST dchkdmd.f90)

set(ZEIGTST zchkee.F
   zbdt01.f zbdt02.f zbdt03.f zbdt05.f
   zchkbb.f zchkbd.f zchkbk.f zchkbl.f zchkec.f
   zchkgg.f zchkgk.f zchkgl.f zchkhb.f zchkhs.f zchkst.f zchkst2stg.f zchkhb2stg.f
   zckcsd.f zckglm.f zckgqr.f zckgsv.f zcklse.f zcsdts.f
   zdrges.f zdrgev.f zdrges3.f zdrgev3.f zdrgsx.f zdrgvx.f
   zdrvbd.f zdrves.f zdrvev.f zdrvsg.f zdrvsg2stg.f
   zdrvst.f zdrvst2stg.f zdrvsx.f zdrvvx.f
   zerrbd.f zerrec.f zerred.f zerrgg.f zerrhs.f zerrst.f
   zget02.f zget10.f zget22.f zget23.f zget24.f
   zget35.f zget36.f zget37.f zget38.f zget51.f zget52.f
   zget54.f zglmts.f zgqrts.f zgrqts.f zgsvts3.f
   zhbt21.f zhet21.f zhet22.f zhpt21.f zhst01.f
   zlarfy.f zlarhs.f zlatm4.f zlctes.f zlctsx.f zlsets.f zsbmv.f
   zsgt01.f zslect.f zsyl01.f
   zstt21.f zstt22.f zunt01.f zunt03.f)

set(ZDMDEIGTST zchkdmd.f90)

macro(add_eig_executable name)
  add_executable(${name} ${ARGN})
  target_link_libraries(${name} ${LIBNAMEPREFIX}openblas${LIBNAMESUFFIX}${SUFFIX64_UNDERSCORE})

  if (USE_OPENMP AND (${CMAKE_Fortran_COMPILER_ID} STREQUAL GNU) AND (${CMAKE_C_COMPILER_ID} STREQUAL Clang))
	  string(REGEX REPLACE "-fopenmp" "" CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS}")
    target_link_libraries(${name} omp pthread)
  endif()

#${TMGLIB} ../${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
endmacro()

if(BUILD_SINGLE)
add_eig_executable(xeigtsts ${SEIGTST} ${SCIGTST} ${AEIGTST})
add_eig_executable(xdmdeigtsts ${SDMDEIGTST})
endif()

if(BUILD_COMPLEX)
add_eig_executable(xeigtstc ${CEIGTST} ${SCIGTST} ${AEIGTST})
add_eig_executable(xdmdeigtstc ${CDMDEIGTST})
endif()

if(BUILD_DOUBLE)
add_eig_executable(xeigtstd ${DEIGTST} ${DZIGTST} ${AEIGTST})
add_eig_executable(xdmdeigtstd ${DDMDEIGTST})
endif()

if(BUILD_COMPLEX16)
add_eig_executable(xeigtstz ${ZEIGTST} ${DZIGTST} ${AEIGTST})
add_eig_executable(xdmdeigtstz ${ZDMDEIGTST})
endif()

=== lapack-netlib/TESTING/LIN/CMakeLists.txt ===
set(ALINTST
   aladhd.f alaerh.f alaesm.f alahd.f alareq.f
   alasum.f alasvm.f chkxer.f icopy.f ilaenv.f xlaenv.f xerbla.f)

set(SCLNTST slaord.f)

set(DZLNTST dlaord.f)

set(SLINTST schkaa.F
   schkeq.f schkgb.f schkge.f schkgt.f
   schklq.f schkpb.f schkpo.f schkps.f schkpp.f
   schkpt.f schkq3.f schkqp3rk.f schkql.f schkqr.f schkrq.f
   schksp.f schksy.f schksy_rook.f schksy_rk.f 
   schksy_aa.f schksy_aa_2stage.f 
   schktb.f schktp.f schktr.f
   schktz.f
   sdrvgt.f sdrvls.f sdrvpb.f
   sdrvpp.f sdrvpt.f sdrvsp.f sdrvsy_rook.f sdrvsy_rk.f 
   sdrvsy_aa.f sdrvsy_aa_2stage.f
   serrgt.f serrlq.f serrls.f
   serrps.f serrql.f serrqp.f serrqr.f
   serrrq.f serrtr.f serrtz.f
   sgbt01.f sgbt02.f sgbt05.f sgeqls.f
   sgerqs.f sget01.f sget02.f
   sget03.f sget04.f sget06.f sget07.f sgtt01.f sgtt02.f
   sgtt05.f slaptm.f slarhs.f slatb4.f slatb5.f slattb.f slattp.f
   slattr.f slavsp.f slavsy.f slavsy_rook.f slqt01.f slqt02.f
   slqt03.f spbt01.f spbt02.f spbt05.f spot01.f
   spot02.f spot03.f spot05.f spst01.f sppt01.f
   sppt02.f sppt03.f sppt05.f sptt01.f sptt02.f
   sptt05.f sqlt01.f sqlt02.f sqlt03.f sqpt01.f
   sqrt01.f sqrt01p.f sqrt02.f sqrt03.f sqrt11.f sqrt12.f
   sqrt13.f sqrt14.f sqrt15.f sqrt16.f sqrt17.f
   srqt01.f srqt02.f srqt03.f srzt01.f srzt02.f
   sspt01.f ssyt01.f ssyt01_rook.f ssyt01_3.f 
   ssyt01_aa.f
   stbt02.f stbt03.f stbt05.f stbt06.f stpt01.f
   stpt02.f stpt03.f stpt05.f stpt06.f strt01.f
   strt02.f strt03.f strt05.f strt06.f
   sgennd.f sqrt04.f sqrt05.f schkqrt.f serrqrt.f schkqrtp.f serrqrtp.f
   schklqt.f schklqtp.f schktsqr.f
   serrlqt.f serrlqtp.f serrtsqr.f stsqr01.f slqt04.f slqt05.f
   schkorhr_col.f serrorhr_col.f sorhr_col01.f sorhr_col02.f)

if(USE_XBLAS)
  list(APPEND SLINTST sdrvgbx.f sdrvgex.f sdrvsyx.f sdrvpox.f
                      serrvxx.f serrgex.f serrsyx.f serrpox.f
                      sebchvxx.f)
else()
  list(APPEND SLINTST sdrvgb.f sdrvge.f sdrvsy.f sdrvpo.f
                      serrvx.f serrge.f serrsy.f serrpo.f)
endif()

set(CLINTST cchkaa.F
   cchkeq.f cchkgb.f cchkge.f cchkgt.f
   cchkhe.f cchkhe_rook.f cchkhe_rk.f 
   cchkhe_aa.f cchkhe_aa_2stage.f
   cchkhp.f cchklq.f cchkpb.f
   cchkpo.f cchkps.f cchkpp.f cchkpt.f cchkq3.f cchkqp3rk.f cchkql.f
   cchkqr.f cchkrq.f cchksp.f cchksy.f cchksy_rook.f cchksy_rk.f
   cchksy_aa.f cchksy_aa_2stage.f
   cchktb.f
   cchktp.f cchktr.f cchktz.f
   cdrvgt.f cdrvhe_rook.f cdrvhe_rk.f 
   cdrvhe_aa.f cdrvhe_aa_2stage.f cdrvsy_aa_2stage.f
   cdrvhp.f
   cdrvls.f cdrvpb.f cdrvpp.f cdrvpt.f
   cdrvsp.f cdrvsy_rook.f cdrvsy_rk.f 
   cdrvsy_aa.f 
   cerrgt.f cerrlq.f
   cerrls.f cerrps.f cerrql.f cerrqp.f
   cerrqr.f cerrrq.f cerrtr.f cerrtz.f
   cgbt01.f cgbt02.f cgbt05.f cgeqls.f
   cgerqs.f cget01.f cget02.f
   cget03.f cget04.f cget07.f cgtt01.f cgtt02.f
   cgtt05.f chet01.f chet01_rook.f chet01_3.f
   chet01_aa.f
   chpt01.f claipd.f claptm.f clarhs.f clatb4.f clatb5.f
   clatsp.f clatsy.f clattb.f clattp.f clattr.f
   clavhe.f clavhe_rook.f clavhp.f clavsp.f clavsy.f clavsy_rook.f clqt01.f
   clqt02.f clqt03.f cpbt01.f cpbt02.f cpbt05.f
   cpot01.f cpot02.f cpot03.f cpot05.f cpst01.f
   cppt01.f cppt02.f cppt03.f cppt05.f cptt01.f
   cptt02.f cptt05.f cqlt01.f cqlt02.f cqlt03.f
   cqpt01.f cqrt01.f cqrt01p.f cqrt02.f cqrt03.f cqrt11.f
   cqrt12.f cqrt13.f cqrt14.f cqrt15.f cqrt16.f
   cqrt17.f crqt01.f crqt02.f crqt03.f crzt01.f crzt02.f
   csbmv.f  cspt01.f
   cspt02.f cspt03.f csyt01.f csyt01_rook.f csyt01_3.f
   csyt01_aa.f 
   csyt02.f csyt03.f
   ctbt02.f ctbt03.f ctbt05.f ctbt06.f ctpt01.f
   ctpt02.f ctpt03.f ctpt05.f ctpt06.f ctrt01.f
   ctrt02.f ctrt03.f ctrt05.f ctrt06.f
   sget06.f cgennd.f
   cqrt04.f cqrt05.f cchkqrt.f cerrqrt.f cchkqrtp.f cerrqrtp.f
   cchklqt.f cchklqtp.f cchktsqr.f
   cerrlqt.f cerrlqtp.f cerrtsqr.f ctsqr01.f clqt04.f clqt05.f
   cchkunhr_col.f cerrunhr_col.f cunhr_col01.f cunhr_col02.f)

if(USE_XBLAS)
  list(APPEND CLINTST cdrvgbx.f cdrvgex.f cdrvhex.f cdrvsyx.f cdrvpox.f
                      cerrvxx.f cerrgex.f cerrhex.f cerrsyx.f cerrpox.f
                      cebchvxx.f)
else()
  list(APPEND CLINTST cdrvgb.f cdrvge.f cdrvhe.f cdrvsy.f cdrvpo.f
                      cerrvx.f cerrge.f cerrhe.f cerrsy.f cerrpo.f)
endif()

set(DLINTST dchkaa.F
   dchkeq.f dchkgb.f dchkge.f dchkgt.f
   dchklq.f dchkpb.f dchkpo.f dchkps.f dchkpp.f
   dchkpt.f dchkq3.f dchkqp3rk.f dchkql.f dchkqr.f dchkrq.f
   dchksp.f dchksy.f dchksy_rook.f dchksy_rk.f 
   dchksy_aa.f dchksy_aa_2stage.f
   dchktb.f dchktp.f dchktr.f
   dchktz.f
   ddrvgt.f ddrvls.f ddrvpb.f
   ddrvpp.f ddrvpt.f ddrvsp.f ddrvsy_rook.f ddrvsy_rk.f 
   ddrvsy_aa.f ddrvsy_aa_2stage.f
   derrgt.f derrlq.f derrls.f
   derrps.f derrql.f derrqp.f derrqr.f
   derrrq.f derrtr.f derrtz.f
   dgbt01.f dgbt02.f dgbt05.f dgeqls.f
   dgerqs.f dget01.f dget02.f
   dget03.f dget04.f dget06.f dget07.f dgtt01.f dgtt02.f
   dgtt05.f dlaptm.f dlarhs.f dlatb4.f dlatb5.f dlattb.f dlattp.f
   dlattr.f dlavsp.f dlavsy.f dlavsy_rook.f dlqt01.f dlqt02.f
   dlqt03.f dpbt01.f dpbt02.f dpbt05.f dpot01.f
   dpot02.f dpot03.f dpot05.f dpst01.f dppt01.f
   dppt02.f dppt03.f dppt05.f dptt01.f dptt02.f
   dptt05.f dqlt01.f dqlt02.f dqlt03.f dqpt01.f
   dqrt01.f dqrt01p.f dqrt02.f dqrt03.f dqrt11.f dqrt12.f
   dqrt13.f dqrt14.f dqrt15.f dqrt16.f dqrt17.f
   drqt01.f drqt02.f drqt03.f drzt01.f drzt02.f
   dspt01.f dsyt01.f dsyt01_rook.f dsyt01_3.f
   dsyt01_aa.f
   dtbt02.f dtbt03.f dtbt05.f dtbt06.f dtpt01.f
   dtpt02.f dtpt03.f dtpt05.f dtpt06.f dtrt01.f
   dtrt02.f dtrt03.f dtrt05.f dtrt06.f
   dgennd.f
   dqrt04.f dqrt05.f dchkqrt.f derrqrt.f dchkqrtp.f derrqrtp.f
   dchklq.f dchklqt.f dchklqtp.f dchktsqr.f
   derrlqt.f derrlqtp.f derrtsqr.f dtsqr01.f dlqt04.f dlqt05.f
   dchkorhr_col.f derrorhr_col.f dorhr_col01.f dorhr_col02.f)

if(USE_XBLAS)
  list(APPEND DLINTST ddrvgbx.f ddrvgex.f ddrvsyx.f ddrvpox.f
                      derrvxx.f derrgex.f derrsyx.f derrpox.f
                      debchvxx.f)
else()
  list(APPEND DLINTST ddrvgb.f ddrvge.f ddrvsy.f ddrvpo.f
                      derrvx.f derrge.f derrsy.f derrpo.f)
endif()

set(ZLINTST zchkaa.F
   zchkeq.f zchkgb.f zchkge.f zchkgt.f
   zchkhe.f zchkhe_rook.f zchkhe_rk.f 
   zchkhe_aa.f zchkhe_aa_2stage.f
   zchkhp.f zchklq.f zchkpb.f
   zchkpo.f zchkps.f zchkpp.f zchkpt.f zchkq3.f zchkqp3rk.f zchkql.f
   zchkqr.f zchkrq.f zchksp.f zchksy.f zchksy_rook.f zchksy_rk.f
   zchksy_aa.f  zchksy_aa_2stage.f
   zchktb.f
   zchktp.f zchktr.f zchktz.f
   zdrvgt.f zdrvhe_rook.f zdrvhe_rk.f 
   zdrvhe_aa.f  zdrvhe_aa_2stage.f
   zdrvhp.f
   zdrvls.f zdrvpb.f zdrvpp.f zdrvpt.f
   zdrvsp.f zdrvsy_rook.f zdrvsy_rk.f 
   zdrvsy_aa.f zdrvsy_aa_2stage.f 
   zerrgt.f zerrlq.f
   zerrls.f zerrps.f zerrql.f zerrqp.f
   zerrqr.f zerrrq.f zerrtr.f zerrtz.f
   zgbt01.f zgbt02.f zgbt05.f zgeqls.f
   zgerqs.f zget01.f zget02.f
   zget03.f zget04.f zget07.f zgtt01.f zgtt02.f
   zgtt05.f zhet01.f zhet01_rook.f zhet01_3.f
   zhet01_aa.f
   zhpt01.f zlaipd.f zlaptm.f zlarhs.f zlatb4.f zlatb5.f
   zlatsp.f zlatsy.f zlattb.f zlattp.f zlattr.f
   zlavhe.f zlavhe_rook.f zlavhp.f zlavsp.f zlavsy.f zlavsy_rook.f zlqt01.f
   zlqt02.f zlqt03.f zpbt01.f zpbt02.f zpbt05.f
   zpot01.f zpot02.f zpot03.f zpot05.f zpst01.f
   zppt01.f zppt02.f zppt03.f zppt05.f zptt01.f
   zptt02.f zptt05.f zqlt01.f zqlt02.f zqlt03.f
   zqpt01.f zqrt01.f zqrt01p.f zqrt02.f zqrt03.f zqrt11.f
   zqrt12.f zqrt13.f zqrt14.f zqrt15.f zqrt16.f
   zqrt17.f zrqt01.f zrqt02.f zrqt03.f zrzt01.f zrzt02.f
   zsbmv.f  zspt01.f
   zspt02.f zspt03.f zsyt01.f zsyt01_rook.f zsyt01_3.f
   zsyt01_aa.f
   zsyt02.f zsyt03.f
   ztbt02.f ztbt03.f ztbt05.f ztbt06.f ztpt01.f
   ztpt02.f ztpt03.f ztpt05.f ztpt06.f ztrt01.f
   ztrt02.f ztrt03.f ztrt05.f ztrt06.f
   dget06.f zgennd.f
   zqrt04.f zqrt05.f zchkqrt.f zerrqrt.f zchkqrtp.f zerrqrtp.f
   zchklqt.f zchklqtp.f zchktsqr.f
   zerrlqt.f zerrlqtp.f zerrtsqr.f ztsqr01.f zlqt04.f zlqt05.f
   zchkunhr_col.f zerrunhr_col.f zunhr_col01.f zunhr_col02.f)

if(USE_XBLAS)
  list(APPEND ZLINTST zdrvgbx.f zdrvgex.f zdrvhex.f zdrvsyx.f zdrvpox.f
                      zerrvxx.f zerrgex.f zerrhex.f zerrsyx.f zerrpox.f
                      zebchvxx.f)
else()
  list(APPEND ZLINTST zdrvgb.f zdrvge.f zdrvhe.f zdrvsy.f zdrvpo.f
                      zerrvx.f zerrge.f zerrhe.f zerrsy.f zerrpo.f)
endif()

set(DSLINTST dchkab.f
	ddrvab.f ddrvac.f derrab.f derrac.f dget08.f
	alaerh.f alahd.f  aladhd.f alareq.f
	chkxer.f dlarhs.f dlatb4.f xerbla.f
	dget02.f dpot06.f)

set(ZCLINTST zchkab.f
	zdrvab.f zdrvac.f zerrab.f zerrac.f zget08.f
	alaerh.f alahd.f  aladhd.f alareq.f
	chkxer.f zget02.f zlarhs.f zlatb4.f
	zsbmv.f  xerbla.f zpot06.f zlaipd.f)

set(SLINTSTRFP schkrfp.f sdrvrfp.f sdrvrf1.f sdrvrf2.f sdrvrf3.f sdrvrf4.f serrrfp.f
	slatb4.f slarhs.f sget04.f spot01.f spot03.f spot02.f
	chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f)

set(DLINTSTRFP dchkrfp.f ddrvrfp.f ddrvrf1.f ddrvrf2.f ddrvrf3.f ddrvrf4.f derrrfp.f
	dlatb4.f dlarhs.f dget04.f dpot01.f dpot03.f dpot02.f
	chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f)

set(CLINTSTRFP cchkrfp.f cdrvrfp.f cdrvrf1.f cdrvrf2.f cdrvrf3.f cdrvrf4.f cerrrfp.f
  claipd.f clatb4.f clarhs.f csbmv.f cget04.f cpot01.f cpot03.f cpot02.f
  chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f)

set(ZLINTSTRFP zchkrfp.f zdrvrfp.f zdrvrf1.f zdrvrf2.f zdrvrf3.f zdrvrf4.f zerrrfp.f
  zlatb4.f zlaipd.f zlarhs.f zsbmv.f zget04.f zpot01.f zpot03.f zpot02.f
  chkxer.f xerbla.f alaerh.f aladhd.f alahd.f alasvm.f)

macro(add_lin_executable name)
  add_executable(${name} ${ARGN})
  target_link_libraries(${name} ${LIBNAMEPREFIX}openblas${LIBNAMESUFFIX}${SUFFIX64_UNDERSCORE})
  if (USE_OPENMP AND (${CMAKE_Fortran_COMPILER_ID} STREQUAL GNU) AND (${CMAKE_C_COMPILER_ID} STREQUAL Clang))
	string(REGEX REPLACE "-fopenmp" "" CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS}")
        target_link_libraries(${name} omp pthread)
  endif()
#${TMGLIB} ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
endmacro()

if(BUILD_SINGLE)
  add_lin_executable(xlintsts ${ALINTST} ${SLINTST} ${SCLNTST})
  add_lin_executable(xlintstrfs ${SLINTSTRFP})
endif()

if(BUILD_DOUBLE)
  add_lin_executable(xlintstd ${ALINTST} ${DLINTST} ${DZLNTST})
  add_lin_executable(xlintstrfd ${DLINTSTRFP})
endif()

if(BUILD_SINGLE AND BUILD_DOUBLE)
  add_lin_executable(xlintstds ${DSLINTST})
endif()

if(BUILD_COMPLEX)
  add_lin_executable(xlintstc ${ALINTST} ${CLINTST} ${SCLNTST})
  add_lin_executable(xlintstrfc ${CLINTSTRFP})
endif()

if(BUILD_COMPLEX16)
  add_lin_executable(xlintstz ${ALINTST} ${ZLINTST} ${DZLNTST})
  add_lin_executable(xlintstrfz ${ZLINTSTRFP})
endif()

if(BUILD_COMPLEX AND BUILD_COMPLEX16)
  add_lin_executable(xlintstzc ${ZCLINTST})
endif()

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>
# Contributor: Jürgen Pfeifer <juergen@familiepfeifer.de>

_realname=OpenBLAS
pkgbase=mingw-w64-openblas
pkgname=("${MINGW_PACKAGE_PREFIX}-openblas"
         $([[ "${CARCH}" == "i686" ]] || echo "${MINGW_PACKAGE_PREFIX}-openblas64"))
pkgver=0.3.28
pkgrel=3
pkgdesc="An optimized BLAS library based on GotoBLAS2 1.13 BSD, providing optimized blas, lapack, and cblas (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.openblas.net/"
msys2_repository_url="https://github.com/OpenMathLib/OpenBLAS"
msys2_references=(
  'archlinux: openblas'
  "cpe: cpe:/a:openblas_project:openblas"
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran")
         "${MINGW_PACKAGE_PREFIX}-omp")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "dos2unix")
options=('!buildflags')
source=(https://github.com/OpenMathLib/OpenBLAS/releases/download/v${pkgver}/${_realname}-${pkgver}.tar.gz
        002-lgfortran-requires-lquadmath.patch
        004-aarch64-detection.patch
        005-fix-pkgconfig-files.patch)
sha256sums=('f1003466ad074e9b0c8d421a204121100b0751c96fc6fcf3d1456bd12f8a00a1'
            'c147ec053bdf0387d499372472365aa829db0d8200b6828b0ebce5209e8603fd'
            '70ce007ff4f6c2a127f9835ce9cd85081707cf3bcccddcfaa06817b06f69c941'
            'a5c94f3c089a85c691ce67f0ad2e090d7d4ef951beee040248a5eaf0ee12b33d')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Np1 -i "${srcdir}"/${_patch}
  done
}

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}

  apply_patch_with_msg \
    002-lgfortran-requires-lquadmath.patch \
    004-aarch64-detection.patch \
    005-fix-pkgconfig-files.patch
}

_build_openblas() {
  _idx_opt=$1

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${CARCH} == aarch64 ]]; then
    # Clang wasn't able to compile all the kernels inside the arm64 folder,
    # Enable only the cores known to build on Windows on ARM
    _extra_config+=("-DTARGET=CORTEXA53" "-DDYNAMIC_ARCH=ON" "-DDYNAMIC_LIST='CORTEXA53;CORTEXA57;CORTEXA72;CORTEXA73;CORTEXA76;CORTEXX1;THUNDERX;TSV110;EMAG8180'")
  else
    _extra_config+=("-DTARGET=CORE2" "-DDYNAMIC_ARCH=ON")
  fi

  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    _extra_config+=("-DOpenMP_Fortran_FLAGS=-fopenmp" "-DOpenMP_Fortran_LIB_NAMES=omp")
    export FFLAGS="-I${MINGW_PREFIX}/include"
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DBUILD_SHARED_LIBS=ON \
    -DBUILD_STATIC_LIBS=ON \
    -DBUILD_TESTING=OFF \
    -DUSE_THREAD=ON \
    -DNUM_THREADS=64 \
    -DUSE_OPENMP=ON \
    "${_extra_config[@]}" \
    ${_idx_opt} \
    ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM}-32 && cd "${srcdir}"/build-${MSYSTEM}-32

  msg2 "Build OpenBLAS with 32-bit indexing"
  _build_openblas ""

  if [ "${CARCH}" != "i686" ]; then
    mkdir -p "${srcdir}"/build-${MSYSTEM}-64 && cd "${srcdir}"/build-${MSYSTEM}-64

    msg2 "Build OpenBLAS with 64-bit indexing"
    _build_openblas "-DBINARY=64 -DINTERFACE64=1"
  fi
}

check() {
  cd "${srcdir}"/build-${MSYSTEM}-32
  ${MINGW_PREFIX}/bin/cmake -DBUILD_TESTING=ON ../${_realname}-${pkgver}
  ${MINGW_PREFIX}/bin/cmake --build .
  ${MINGW_PREFIX}/bin/ctest

  if [ "${CARCH}" != "i686" ]; then
    cd "${srcdir}/build-${MSYSTEM}-64"
    ${MINGW_PREFIX}/bin/cmake -DBUILD_TESTING=ON ../${_realname}-${pkgver}
    ${MINGW_PREFIX}/bin/cmake --build .
    ${MINGW_PREFIX}/bin/ctest
  fi
}

package_openblas() {
  pkgdesc="An optimized BLAS library based on GotoBLAS2 1.13 BSD, providing optimized blas, lapack, and cblas (mingw-w64)"

  cd "${srcdir}"/build-${MSYSTEM}-32

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/OpenBLAS/*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done

  # Install License
  install -Dm0644 "${srcdir}"/${_realname}-${pkgver}/LICENSE "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
  install -Dm0644 "${srcdir}"/${_realname}-${pkgver}/lapack-netlib/LICENSE "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE-lapack
}

package_openblas64() {
  pkgdesc="An optimized BLAS library based on GotoBLAS2 1.13 BSD, providing optimized blas, lapack, and cblas with 64-bit indexing (mingw-w64)"
  provides=()
  conflicts=()
  replaces=()

  cd "${srcdir}"/build-${MSYSTEM}-64

  DESTDIR=${pkgdir} ${MINGW_PREFIX}/bin/cmake --install .

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/OpenBLAS64/*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done

  # Install License
  install -Dm0644 "${srcdir}"/${_realname}-${pkgver}/LICENSE "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}64/LICENSE
  install -Dm0644 "${srcdir}"/${_realname}-${pkgver}/lapack-netlib/LICENSE "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}64/LICENSE-lapack
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
